#include "roots.h"

Roots::Roots() {
	Roots(0);
}

Roots::Roots(int count) {
	if (count < 0)
		throw "Number of roots can't be negative.";
	Roots::set = count;
	Roots::len = count*2+1;
	Roots::roots = new float[len];
}

Roots::Roots(Roots *roots) {
	len = roots->len;
	set = roots->set;
	if (set > len)
		throw "Wierd object passed to =constructor.";
	Roots::roots = new float[len];
	for (int i = 0; i < set; i++)
		Roots::roots[i] = roots->roots[i];
}

Roots::~Roots() {
	delete [] roots;
}

int Roots::getCount() {
	return set;
}

void Roots::addRoot(float root) {
	if (set >= len)
		doubleCapacity();
	roots[set++] = root;
}

float Roots::getRoot(int i) {
	if (set == 0)
		throw "No roots.";
	if ((i < 0) || (i >= set))
		throw "Want root out of boundary.";
	return roots[i];
}

void Roots::doubleCapacity() {
		len *= 2;
		float *tmp = roots;
		roots = new float[len];
		for (int i = 0; i < set; i++)
			roots[i] = tmp[i];
}
